program test;

 uses Crt;

 type
  TestRec=record
   RecText:     string;
  end;

 const
  PosX=1;
  PosY=5;

 var
  Count:        word;
  Code:         integer;
  TestFile:     file of TestRec;
  Rec:          TestRec;
  AverReadTime: longint;
  StgReadtime:  longint;
  SysTimer:     longint absolute $0040:$006C;
  FileSize:     single;
  NumElem:      longint;

 procedure Start(var X:longint);
  begin
    X:=SysTimer;
    while X=SysTimer do;
    X:=SysTimer
  end;

 procedure Finish(var X:longint);
  begin
    X:=SysTimer-X
  end;

 procedure Mess(Msg:string);
  begin
   GotoXY(PosX,PosY);
   ClrEol;
   writeln(Msg);
  end;

 procedure Report(Msg:string;X:longint);
  begin
   GotoXY(PosX,PosY);
   ClrEol;
   writeln(Msg,':',X/18.2*1000/NumElem:5:2,' msec')
  end;

 procedure CreateRec;
  begin
   Rec.RecText:=' ';
  end;

 procedure CreateFile;
  begin
   Count:=0;
   Rewrite(TestFile);
   while Count < NumElem do
    begin
     Write(TestFile,Rec);
     inc (Count);
    end;
  end;

 procedure AverageRead;
  var
   NumRec:      word;
  begin
   Count:=0;
   Reset(TestFile);
   Randomize;
   while Count < NumElem do
    begin
     NumRec:=Random(NumElem);
     Seek(TestFile,NumRec);
     Read(TestFile,Rec);
     inc (Count);
    end;
  end;

 procedure StrongRead;
  var
   NumRec:      word;
  begin
   Count:=0;
   Reset(TestFile);
   while Count < NumElem do
    begin
     NumRec:=Count;
     Seek(TestFile,NumRec);
     Read(TestFile,Rec);
     inc (Count);
    end;
  end;

 procedure DeleteFile;
  begin
   Erase(TestFile);
  end;

begin
 ClrScr;
 writeln(' Usage: test filesize');
 writeln(' filesize specified size file for testing in Kbytes');
 if ParamCount = 0 then Halt;
 Val( ParamStr(1),Filesize,Code);
 NumElem:=Round(FileSize*4);
 Assign(TestFile,'test.dat');
 CreateRec;
 Mess('Creating new testfile.');
 CreateFile;
 Mess('Testing average reading.');
 Start(AverReadTime);
 AverageRead;
 Finish(AverReadTime);
 Mess('Testing strong reading.');
 Start(StgReadTime);
 StrongRead;
 Finish(StgReadTime);
 Mess('Deleting testfile.');
 DeleteFile;
 Report('Average time reading one record ',AverReadTime);
 writeln('Time reading one record',StgReadTime/18.2*1000/NumElem:5:2,' msec');
end.
